import random
import turtle

class RGB:
    def __init__(self, r, g, b):
        self.r = r
        self.g = g
        self.b = b
    
    def __add__(self, masik):
        return RGB(self.r + masik.r,
                   self.g + masik.g,
                   self.b + masik.b)

class Intervallum:
    def __init__(self, min, max):
        self.min = min
        self.max = max

def itv_rand(itv): # Intervallum
    return random.uniform(itv.min, itv.max)

class AgAdat:
    def __init__(self, doles, helyzet, rovidules):
        self.doles = doles
        self.helyzet = helyzet
        self.rovidules = rovidules

# csak a vonalat rajzolja, illetve a színt állítja be
def szakasz(n, hossz, szin):
    turtle.pencolor(szin.r, szin.g, szin.b)
    turtle.down()
    turtle.width(n)
    turtle.forward(hossz)
    turtle.up()
    turtle.backward(hossz)

def fat_rajzol(n, agak, hossz, dolesrand, szin, szin_valtozas):
    if n == 0:
        return
    
    szakasz(n, hossz, szin)
    for ag in agak:
        # beállítjuk, honnan indul majd a következő ág
        szog = ag.doles + itv_rand(dolesrand)
        turtle.forward(hossz * (1 - ag.helyzet)) 
        turtle.left(szog)
        fat_rajzol(n - 1, agak, hossz * (1 - ag.rovidules), dolesrand, szin + szin_valtozas, szin_valtozas)
        # visszamegyünk az eredeti pozícióba
        turtle.right(szog)
        turtle.backward(hossz * (1 - ag.helyzet)) 
    
    # ha ez benne van, látszik a rajzolás
    if n > 4:
        turtle.update()

def randomfa():
    # a rekurzió mélysége
    melyseg = 8

    # az ágak tulajdonságai, véletlenszámok határai
    doles = Intervallum( 15, 30 )
    dolesrand = Intervallum( -5, +5 )
    helyzet = Intervallum( 0.4, 0.6 )
    rovidules = Intervallum( 0.2, 0.4 )
    roviduleskozepso = Intervallum( 0.2, 0.3 )
    meret = Intervallum( 60, 80 )

    # világosbarna alapszín, és ahhoz képesti különbség
    # piros és kék 0-ra csökken, zöld a megadott színig nő
    szin = RGB(0.65, 0.16, 0.16)
    szin_valtozas = RGB(-szin.r / melyseg, (0.85 - szin.g) / melyseg, -szin.b / melyseg)
    
    # véletlenszerű ágak
    agak = [
        AgAdat(+itv_rand(doles), itv_rand(helyzet), itv_rand(rovidules)),
        AgAdat(0, 0, itv_rand(roviduleskozepso)),
        AgAdat(-itv_rand(doles), itv_rand(helyzet), itv_rand(rovidules)),
    ]

    fat_rajzol(melyseg, agak, itv_rand(meret), dolesrand, szin, szin_valtozas)

def hatter():
    turtle.up()
    turtle.left(90)
    turtle.backward(300)
    turtle.right(90)
    
    turtle.bgcolor(0.25, 0.25, 1)
    
    turtle.color(0, 0.6, 0)
    turtle.begin_fill()
    turtle.forward(500)
    turtle.left(90)
    turtle.forward(100)
    turtle.left(90)
    turtle.forward(1000)
    turtle.left(90)
    turtle.forward(100)
    turtle.left(90)
    turtle.forward(500)
    turtle.end_fill()
    turtle.up()
    
    turtle.left(90)
    turtle.forward(80)
    turtle.update()


def main():
    turtle.hideturtle()
    turtle.tracer(0)
    
    hatter()
    randomfa()
    turtle.update()

    turtle.done()

main()
